リッチテキストエディタ(GcRichTextEditor)コントロールは、組み込みのツールバーをカスタマイズすることや、カスタム項目を追加することができます。
ツールバー項目の設定
ツールバーに設定するツールバー項目を設定することができます。
例えば、ツールバーの fontsize 項目のドロップダウンリストに表示する項目をカスタマイズすることができます。
カスタムツールバー
registerToolbarItem メソッドを使用して、ビルドイン以外のカスタム項目をツールバー項目に設定することができます。
カスタムツールバーは以下のプロパティを使用してカスタム項目を構成します。
プロパティ
説明
text
カスタムツールバーボタンのテキストを設定する
tooltip
ツールチップの内容を設定する
enabled
デフォルト状態(有効または無効)を設定する
onSetup
ツールバーが初期化されたときの動作を設定する
onAction
カスタムツールバーボタンを押下するときの動作を設定する
次のサンプルコードは、太字のテキストを挿入するボタンをカスタムツールバー項目に登録する方法を示します。
import "@mescius/inputman.richtexteditor/CSS/gc.inputman.richtexteditor.css";
import { InputMan } from "@mescius/inputman.richtexteditor";
InputMan.appearanceStyle = InputMan.AppearanceStyle.Modern;
const gcRichTextEditor = new InputMan.GcRichTextEditor(
document.getElementById("gcRichTextEditor"),
{
watermarkText: "ここに入力してください...",
toolbar: [
"customButton",
InputMan.GcRichTextEditorToolbarItem.Copy,
InputMan.GcRichTextEditorToolbarItem.FontSize,
InputMan.GcRichTextEditorToolbarItem.FontFamily,
InputMan.GcRichTextEditorToolbarItem.BackColor,
InputMan.GcRichTextEditorToolbarItem.ForeColor,
InputMan.GcRichTextEditorToolbarItem.LineHeight,
InputMan.GcRichTextEditorToolbarItem.Indent,
InputMan.GcRichTextEditorToolbarItem.Outdent,
],
fontSizeList: ["8px", "12px", "16px"],
fontFamilyList: [
{
name: "Impact",
value: "impact",
},
{
name: "Trebuchet MS",
value: "trebuchet ms",
options: ["geneva", "impact"],
},
],
colorList: [
{
title: "Red",
color: "#FF0000",
},
{
title: "Green",
color: "#00FF00",
},
{
title: "Blue",
color: "#0000FF",
},
],
lineHeight: ["3", "5", "10", "15", "20", "30", "40"],
indentation: "100px",
baseUrl:
'$IMDEMOROOT$/lib/purejs/node_modules/@mescius/inputman.richtexteditor/JS',
}
);
gcRichTextEditor.registerToolbarItem("customButton", {
text: "カスタムボタン",
tooltip: "コピーボタンを押下してカスタムボタンを有効にする",
enabled: false,
onSetup: (enableConfig) => {
gcRichTextEditor.addEventListener("copy", () => {
enableConfig.setEnabled(true);
});
},
onAction: () =>
gcRichTextEditor.insertContent(`<strong>こんにちは!</strong>`),
});
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta http-equiv="X-UA-Compatible" content="ie=edge">
<title>リッチテキストエディタコントロール - ツールバー - ツールバーのカスタマイズ</title>
<!-- SystemJS -->
<script src="node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
window.onload = function() {
System.import('./src/app');
}
</script>
</head>
<body>
<textarea id="gcRichTextEditor"></textarea>
</body>
</html>
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/inputman': 'npm:@mescius/inputman/index.js',
'@mescius/inputman/CSS': 'npm:@mescius/inputman/CSS',
'@mescius/inputman.richtexteditor': 'npm:@mescius/inputman.richtexteditor/index.js',
'@mescius/inputman.richtexteditor/CSS': 'npm:@mescius/inputman.richtexteditor/CSS',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
}
});

リッチテキストエディタ(GcRichTextEditor)コントロールは、組み込みのツールバーをカスタマイズすることや、カスタム項目を追加することができます。
ツールバー項目の設定
ツールバーに設定するツールバー項目を設定することができます。
例えば、ツールバーの fontsize 項目のドロップダウンリストに表示する項目をカスタマイズすることができます。
カスタムツールバー
registerToolbarItem メソッドを使用して、ビルドイン以外のカスタム項目をツールバー項目に設定することができます。
カスタムツールバーは以下のプロパティを使用してカスタム項目を構成します。
プロパティ
説明
text
カスタムツールバーボタンのテキストを設定する
tooltip
ツールチップの内容を設定する
enabled
デフォルト状態(有効または無効)を設定する
onSetup
ツールバーが初期化されたときの動作を設定する
onAction
カスタムツールバーボタンを押下するときの動作を設定する
次のサンプルコードは、太字のテキストを挿入するボタンをカスタムツールバー項目に登録する方法を示します。
<template>
<div>
<GcRichTextEditorComponent
ref="rich"
:watermarkText="watermarkText"
:toolbar="toolbar"
:fontSizeList="fontSizeList"
:fontFamilyList="fontFamilyList"
:colorList="colorList"
:lineHeight="lineHeight"
:indentation="indentation"
:baseUrl="baseUrl"
/>
</div>
</template>
<script setup>
import "@mescius/inputman.richtexteditor/CSS/gc.inputman.richtexteditor.css";
import "./styles.css";
import { ref, onMounted } from "vue";
import { GcRichTextEditorComponent } from "@mescius/inputman.richtexteditor.vue";
GC.InputMan.appearanceStyle = GC.InputMan.AppearanceStyle.Modern;
var watermarkText = "ここに入力してください...";
var toolbar = [
"customButton",
GC.InputMan.GcRichTextEditorToolbarItem.Copy,
GC.InputMan.GcRichTextEditorToolbarItem.FontSize,
GC.InputMan.GcRichTextEditorToolbarItem.FontFamily,
GC.InputMan.GcRichTextEditorToolbarItem.BackColor,
GC.InputMan.GcRichTextEditorToolbarItem.ForeColor,
GC.InputMan.GcRichTextEditorToolbarItem.LineHeight,
GC.InputMan.GcRichTextEditorToolbarItem.Indent,
GC.InputMan.GcRichTextEditorToolbarItem.Outdent,
];
var fontSizeList = ["8px", "12px", "16px"];
var fontFamilyList = [
{
name: "Impact",
value: "impact",
},
{
name: "Trebuchet MS",
value: "trebuchet ms",
options: ["geneva", "impact"],
},
];
var colorList = [
{
title: "Red",
color: "#FF0000",
},
{
title: "Green",
color: "#00FF00",
},
{
title: "Blue",
color: "#0000FF",
},
];
var lineHeight = ["3", "5", "10", "15", "20", "30", "40"];
var indentation = "100px";
var baseUrl =
'$IMDEMOROOT$/lib/purejs/node_modules/@mescius/inputman.richtexteditor/JS';
var rich = ref();
onMounted(() => {
const gcRichTextEditor = rich.value.getNestedIMControl();
gcRichTextEditor.registerToolbarItem("customButton", {
text: "カスタムボタン",
tooltip: "コピーボタンを押下してカスタムボタンを有効にする",
enabled: false,
onSetup: (enableConfig) => {
gcRichTextEditor.addEventListener("copy", () => {
enableConfig.setEnabled(true);
});
},
onAction: () =>
gcRichTextEditor.insertContent(`<strong>こんにちは!</strong>`),
});
});
</script>
<style src="./styles.css"></style>
<!doctype html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>リッチテキストエディタコントロール - ツールバー - ツールバーのカスタマイズ</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<script src="node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script src="compiler.js" type="module"></script>
<script>
window.onload = function() {
var System = SystemJS;
System.import("./src/app.js");
}
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
"@mescius/inputman": 'npm:@mescius/inputman/index.js',
"@mescius/inputman.vue": 'npm:@mescius/inputman.vue/lib/gc.inputman.plugin.vue.js',
"@mescius/inputman/CSS": "npm:@mescius/inputman/CSS",
"@mescius/inputman.richtexteditor": "npm:@mescius/inputman.richtexteditor/index.js",
"@mescius/inputman.richtexteditor.vue": "npm:/@mescius/inputman.richtexteditor.vue/lib/gc.inputman.richtexteditor.plugin.vue.js",
"@mescius/inputman.richtexteditor/CSS": "npm:@mescius/inputman.richtexteditor/CSS",
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures/wijmo.culture.ja.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-ja': 'npm:@mescius/spread-sheets-resources-ja/index.js',
'@mescius/spread-sheets/styles': 'npm:@mescius/spread-sheets/styles',
'css': 'npm:systemjs-plugin-css/css.js',
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);